SystemOrganization addCategory: #'Glamour-Test-Morphic'!

TestCase subclass: #GLMMorphicTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Test-Morphic'!

!GLMMorphicTest methodsFor: 'as yet unclassified' stamp: 'tg 11/16/2009 06:28'!
repeatAssert: aBlock equals: aResult

	self assert: (self wait: 1 until: aBlock evaluatesTo: aResult)! !

!GLMMorphicTest methodsFor: 'as yet unclassified' stamp: 'tg 11/16/2009 14:30'!
testChildrenBlock

	| browser window check treeMorph mouseUp treeNodeMorph |
	browser := GLMFinder new.
	check := false.
	browser tree
		children: [:each | check := true. #()].
	window := browser openOn: ($a to: $d).
	treeMorph := 	window submorphs last submorphs first submorphs first submorphs first submorphs first.
	treeNodeMorph := treeMorph scroller submorphs first.
	self assert: treeMorph class = LazyMorphTreeMorph.
	mouseUp := MouseButtonEvent basicNew 
		setType: #mouseUp
		position: (treeNodeMorph bounds origin + (1@1))
		which: 4
		buttons: 7
		hand: (HandMorph new mouseFocus: treeNodeMorph; yourself)
		stamp: nil.
	treeNodeMorph processEvent: mouseUp.
	treeNodeMorph inspect.
	self repeatAssert: [check] equals: true.
"	window delete"! !

!GLMMorphicTest methodsFor: 'as yet unclassified' stamp: 'tg 11/13/2009 09:33'!
testChildrenBlockTakesEntity

	| browser receivedEntity window |
	browser := GLMFinder new.
	receivedEntity := nil.
	browser tree
		children: [:each :entity | receivedEntity := entity. #()].
	window := browser openOn: ($a to: $d).
	self repeatAssert: [receivedEntity] equals: ($a to: $d).
	window delete! !

!GLMMorphicTest methodsFor: 'as yet unclassified' stamp: 'tg 11/16/2009 06:47'!
testColumnBlockTakesEntity

	| browser receivedEntity window |
	browser := GLMFinder new.
	receivedEntity := nil.
	browser table
		column: 'Even' evaluated: [:each :entity | receivedEntity := entity. 'x'].
	window := browser openOn: (1 to: 5).
	self repeatAssert: [receivedEntity] equals: (1 to: 5).
	window delete! !

!GLMMorphicTest methodsFor: 'as yet unclassified' stamp: 'tg 11/13/2009 09:40'!
testSpawnFinder

	| browser window check |
	browser := GLMFinder new.
	window := browser openOn: ($a to: $d).
	self repeatAssert: [window submorphs last class] equals: GLMPaneScroller.
	window delete! !

!GLMMorphicTest methodsFor: 'as yet unclassified' stamp: 'tg 11/16/2009 15:11'!
testSpawnTableLayoutBrowser

	| browser window check |
	browser := GLMTabulator new.
	window := browser openOn: ($a to: $d).
	self repeatAssert: [
		window submorphs last 
					submorphs last 
						submorphs last 
							submorphs last class] equals: LazyMorphTreeMorph.
	window delete! !

!GLMMorphicTest methodsFor: 'as yet unclassified' stamp: 'tg 11/13/2009 09:15'!
wait: maxWaitSeconds until: validateBlock evaluatesTo: expectedResult
	"Evaluate validateBlock until it returns expectedResult or 
maxWaitSeconds have passed,
	 pausing between evaluations.  Return the last result of validateBlock 
value"

	| startTime result |
	startTime := Time secondClock.
	[result := validateBlock value = expectedResult] whileFalse:
			[Time secondClock - startTime > maxWaitSeconds ifTrue: [^result].
			(Delay forMilliseconds: 50) wait].
	^ result
! !
